'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _yylibUi = require('yylib-ui');

var _reactRouter = require('react-router');

var _UrlUtils = require('yylib-utils/UrlUtils');

var _UrlUtils2 = _interopRequireDefault(_UrlUtils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var field = _yylibUi.YYClass.field,
    PropTypes = _yylibUi.YYClass.PropTypes;


function conv(dataItem) {
    return dataItem;
}

function noop() {}

var uiMeta = {
    name: 'ijz-listitem',
    fields: [
    //field 参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('prefixCls', 'ijz-listitem', PropTypes.string, false, '样式名前缀'), field('className', '', PropTypes.string, false, '样式'), field('dataItem', null, PropTypes.object, false, '行数据集')]
};

var uiMetaHeader = {
    name: 'ijz-listitem-header',
    fields: [
    //field 参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('prefixCls', 'ijz-listitem-header', PropTypes.string, false, '样式名前缀'), field('className', '', PropTypes.string, false, '样式'), field('renderItemHeaderLeft', null, PropTypes.func, false, '头部左侧区域自定义渲染'), field('renderItemHeaderRight', null, PropTypes.func, false, '头部右侧区域自定义渲染')]
};

var uiMetaContent = {
    name: 'ijz-listitem-content',
    fields: [
    //field 参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('prefixCls', 'ijz-listitem-content', PropTypes.string, false, '样式名前缀'), field('className', '', PropTypes.string, false, '样式'), field('renderItemContent', null, PropTypes.func, false, '中部区域自定义渲染'), field('itemContentCol', 2, PropTypes.number, true, '中间区域列数'), field('itemContentRowGutter', 16, PropTypes.number, true, '中间区域栅格间隔')]
};

var uiMetaFooter = {
    name: 'ijz-listitem-footer',
    fields: [
    //field 参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('prefixCls', 'ijz-listitem-footer', PropTypes.string, false, '样式名前缀'), field('className', '', PropTypes.string, false, '样式'), field('renderItemFooterLeft', null, PropTypes.func, false, '脚部左侧区域自定义渲染'), field('renderItemFooterRight', null, PropTypes.func, false, '脚部右侧区域自定义渲染')]
};

var uiMetaItem = {
    name: 'ijz-listitem-item',
    fields: [
    //field 参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('prefixCls', 'ijz-listitem-item', PropTypes.string, false, '样式名前缀'), field('className', '', PropTypes.string, false, '样式'), field('dataItem', null, PropTypes.object, false, '行数据集'), field('dataItemConv', conv, PropTypes.func, false, '(dataItem)=>{let _dataItem; return _dataItem}'), field('layout', 'left', PropTypes.oneOf(['left', 'right']), true, '显示布局'), field('type', 'label', PropTypes.oneOf(['label', 'label-item', 'hyperlink', 'tag', 'button']), true, '显示类型'), field('onClick', noop, PropTypes.func, false, '点击事件')]
};

var IjzListItem = _yylibUi.YYClass.create({
    uiMeta: uiMeta,

    displayName: 'IjzListItem',

    getInitialState: function getInitialState() {
        return {};
    },
    getClassName: function getClassName() {
        var prefixCls = this.props.prefixCls;

        return (0, _classnames2.default)(prefixCls);
    },
    render: function render() {
        var _props = this.props,
            className = _props.className,
            children = _props.children,
            dataItem = _props.dataItem,
            otherProps = _objectWithoutProperties(_props, ['className', 'children', 'dataItem']);

        return _react2.default.createElement(
            'div',
            _extends({}, otherProps, { className: (0, _classnames2.default)(this.getClassName(), className) }),
            _react2.default.Children.map(children, function (item) {
                if (_react2.default.isValidElement(item)) return _react2.default.cloneElement(item, { dataItem: dataItem });
            })
        );
    }
});

var ItemHeader = _yylibUi.YYClass.create({
    uiMeta: uiMetaHeader,

    getInitialState: function getInitialState() {
        return {};
    },
    getClassName: function getClassName() {
        var prefixCls = this.props.prefixCls;

        return (0, _classnames2.default)(prefixCls);
    },
    render: function render() {
        var _props2 = this.props,
            className = _props2.className,
            children = _props2.children,
            dataItem = _props2.dataItem,
            renderItemHeaderLeft = _props2.renderItemHeaderLeft,
            renderItemHeaderRight = _props2.renderItemHeaderRight,
            otherProps = _objectWithoutProperties(_props2, ['className', 'children', 'dataItem', 'renderItemHeaderLeft', 'renderItemHeaderRight']);

        var leftContent = [];
        var rightContent = [];
        _react2.default.Children.map(children, function (item) {
            if (_react2.default.isValidElement(item) && item.type.displayName === 'IjzListItem-item' && item.props.layout === 'left') {
                leftContent.push(_react2.default.cloneElement(item, { dataItem: dataItem }));
            } else if (_react2.default.isValidElement(item) && item.type.displayName === 'IjzListItem-item' && item.props.layout === 'right') {
                rightContent.push(_react2.default.cloneElement(item, { dataItem: dataItem }));
            }
        });

        return _react2.default.createElement(
            'div',
            _extends({}, otherProps, { className: (0, _classnames2.default)(this.getClassName(), className) }),
            _react2.default.createElement(
                'div',
                { className: this.getClassName() + '-left' },
                renderItemHeaderLeft === undefined ? leftContent : renderItemHeaderLeft(dataItem)
            ),
            _react2.default.createElement(
                'div',
                { className: this.getClassName() + '-right' },
                renderItemHeaderRight === undefined ? rightContent : renderItemHeaderRight(dataItem)
            )
        );
    }
});

var ItemContent = _yylibUi.YYClass.create({
    uiMeta: uiMetaContent,

    getInitialState: function getInitialState() {
        return {};
    },
    getClassName: function getClassName() {
        var prefixCls = this.props.prefixCls;

        return (0, _classnames2.default)(prefixCls);
    },
    renderContent: function renderContent() {
        var _props3 = this.props,
            dataItem = _props3.dataItem,
            itemContentCol = _props3.itemContentCol,
            itemContentRowGutter = _props3.itemContentRowGutter,
            children = _props3.children;

        var content = [];
        var rowContext = [];
        var colSpan = 24 / itemContentCol;
        _react2.default.Children.map(function (item, index) {
            rowContext.push(_react2.default.createElement(
                _yylibUi.YYCol,
                { span: colSpan },
                _react2.default.cloneElement(item, { dataItem: dataItem })
            ));
            if ((index + 1) % itemContentCol === 0) {
                content.push(_react2.default.createElement(
                    _yylibUi.YYRow,
                    { gutter: itemContentRowGutter },
                    [].concat(rowContext)
                ));
                rowContext.length = 0;
            }
        });
        while (rowContext.length < itemContentCol) {
            rowContext.push(_react2.default.createElement(_yylibUi.YYCol, { span: colSpan }));
        }
        if (rowContext.length > 0) {
            content.push(_react2.default.createElement(
                _yylibUi.YYRow,
                { gutter: itemContentRowGutter },
                [].concat(rowContext)
            ));
            rowContext.length = 0;
        }
        return content;
    },
    render: function render() {
        var _props4 = this.props,
            className = _props4.className,
            children = _props4.children,
            renderItemContent = _props4.renderItemContent,
            otherProps = _objectWithoutProperties(_props4, ['className', 'children', 'renderItemContent']);

        return _react2.default.createElement(
            'div',
            _extends({}, otherProps, { className: (0, _classnames2.default)(this.getClassName(), className) }),
            renderItemContent ? renderItemContent() : this.renderContent()
        );
    }
});

var ItemFooter = _yylibUi.YYClass.create({
    uiMeta: uiMetaFooter,

    getInitialState: function getInitialState() {
        return {};
    },
    getClassName: function getClassName() {
        var prefixCls = this.props.prefixCls;

        return (0, _classnames2.default)(prefixCls);
    },
    render: function render() {
        var _props5 = this.props,
            className = _props5.className,
            children = _props5.children,
            dataItem = _props5.dataItem,
            renderItemFooterLeft = _props5.renderItemFooterLeft,
            renderItemFooterRight = _props5.renderItemFooterRight,
            otherProps = _objectWithoutProperties(_props5, ['className', 'children', 'dataItem', 'renderItemFooterLeft', 'renderItemFooterRight']);

        var leftContent = [];
        var rightContent = [];
        _react2.default.Children.map(children, function (item) {
            if (_react2.default.isValidElement(item) && item.type.displayName === 'IjzListItem-item' && item.props.layout === 'left') {
                leftContent.push(_react2.default.cloneElement(item, { dataItem: dataItem }));
            } else if (_react2.default.isValidElement(item) && item.type.displayName === 'IjzListItem-item' && item.props.layout === 'right') {
                rightContent.push(_react2.default.cloneElement(item, { dataItem: dataItem }));
            }
        });

        return _react2.default.createElement(
            'div',
            _extends({}, otherProps, { className: (0, _classnames2.default)(this.getClassName(), className) }),
            _react2.default.createElement(
                'div',
                { className: this.getClassName() + '-left' },
                renderItemFooterLeft === undefined ? leftContent : renderItemFooterLeft(dataItem)
            ),
            _react2.default.createElement(
                'div',
                { className: this.getClassName() + '-right' },
                renderItemFooterRight === undefined ? rightContent : renderItemFooterRight(dataItem)
            )
        );
    }
});

var Item = _yylibUi.YYClass.create({
    uiMeta: uiMetaItem,

    displayName: 'IjzListItem-item',

    getInitialState: function getInitialState() {
        return {};
    },
    getClassName: function getClassName() {
        var prefixCls = this.props.prefixCls;

        return (0, _classnames2.default)(prefixCls);
    },
    render: function render() {
        var _props6 = this.props,
            type = _props6.type,
            uikey = _props6.uikey,
            label = _props6.label,
            linkUrl = _props6.linkUrl,
            color = _props6.color,
            dataItem = _props6.dataItem,
            dataItemConv = _props6.dataItemConv,
            onClick = _props6.onClick;

        var defaultColor = "#bfbfbf";
        switch (type) {
            case 'label':
                {
                    return _react2.default.createElement(
                        'div',
                        { className: (0, _classnames2.default)('label') },
                        _react2.default.createElement(
                            'span',
                            null,
                            dataItem === null ? uikey : dataItemConv(dataItem[uikey])
                        )
                    );
                }
            case 'label-item':
                {
                    return _react2.default.createElement(
                        'div',
                        { className: (0, _classnames2.default)('label-item') },
                        _react2.default.createElement(
                            'span',
                            null,
                            label
                        ),
                        _react2.default.createElement(
                            'span',
                            null,
                            dataItem === null ? uikey : dataItemConv(dataItem[uikey])
                        )
                    );
                }
            case 'hyperlink':
                {
                    return _react2.default.createElement(
                        'div',
                        { className: (0, _classnames2.default)('hyperlink') },
                        _react2.default.createElement(
                            _reactRouter.Link,
                            {
                                to: _UrlUtils2.default.fillUrlParams(linkUrl, dataItem) },
                            dataItem === null ? label : dataItem[uikey] ? dataItemConv(dataItem[uikey]) : null
                        )
                    );
                }
            case 'tag':
                {
                    return _react2.default.createElement(
                        'span',
                        { style: { color: color || defaultColor, borderColor: color || defaultColor },
                            className: (0, _classnames2.default)('label-state') },
                        uikey
                    );
                }
            case 'button':
                {
                    return _react2.default.createElement(
                        _yylibUi.YYButton,
                        { className: (0, _classnames2.default)('button-state'),
                            onClick: onClick },
                        uikey
                    );
                }
            default:
                {
                    return null;
                }
        }
    }
});

module.exports = IjzListItem;
module.exports.IjzListItemHeader = ItemHeader;
module.exports.IjzListItemContent = ItemContent;
module.exports.IjzListItemFooter = ItemFooter;
module.exports.IjzListItemField2 = Item;