'use strict';

/**
 * 树形组件
 */
var React = require('react');
var YYClass = require('../base/YYClass');
var PropTypes = YYClass.PropTypes;
var field = YYClass.field;

var _require = require('antd'),
    Tabs = _require.Tabs;

var TabPane = Tabs.TabPane;
//定义META
var uiMeta = {
    name: 'tab',
    fields: [
    // field参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('key', '', PropTypes.string, false, '对应 activeKey'), field('tab', '', PropTypes.oneOf([PropTypes.string, PropTypes.element]), false, '选项卡头显示文字'), field('visible', true, PropTypes.bool, false, '组件是否显示'), field('closeable', false, PropTypes.Bool, false, '标签页是否可以被关闭，仅当type为page及editable为true时生效')]
};

var YYTab = YYClass.create({
    uiMeta: uiMeta,
    render: function render() {
        var cls = this.className() + (this.props.active ? '' : ' ant-tabs-tabpane-hidden');
        return React.createElement(
            'div',
            { className: cls, style: this.props.style },
            React.createElement(
                TabPane,
                this.props,
                this.props.children
            )
        );
    }
});

//规范属性类型
//var propTypes = {
//};
//YYTab.PropTypes = propTypes;

module.exports = YYTab;